### 描述

基于原生封装 button，可自定义样式

### 属性文档

| 属性        | 类型    | 默认值  | 必填 | 说明                                                                                                       |
| ----------- | ------- | ------- | ---- | ---------------------------------------------------------------------------------------------------------- |
| size        | string  | large   | 否   | 按钮的大小                                                                                                 |
| type        | string  | default | 否   | 按钮的样式类型                                                                                             |
| plain       | boolean | false   | 否   | 文字为按钮颜色，背景为白色                                                                                 |
| disabled    | boolean | false   | 否   | 是否禁用                                                                                                   |
| form-type   | string  |         | 否   | 参看微信开发者文档                                                                                         |
| open-type   | string  |         | 否   | 微信开放能力([参考微信开发者文档](https://developers.weixin.qq.com/miniprogram/dev/component/button.html)) |
| round       | boolean | true    | 否   | 按钮形状,椭圆形                                                                                            |
| square      | boolean |         | 否   | 按钮形状，长方形                                                                                           |
| block       | boolean | false   | 否   | 是否为块级元素                                                                                             |
| hover-class | string  |         | 否   | 指定按钮按下去的样式类（**注意与原生不同,样式需要！important 提权，不然无法正常显示**）                    |
| 其他        | string  |         | 否   | 详情参考微信小程序官网                                                                                     |

### size 的合法值

| 值     | 说明                  |
| ------ | --------------------- |
| large  | 默认，大码 width:100% |
| normal | 正常                  |
| small  | 小码                  |

### type 的合法值

| 值      | 说明                   |
| ------- | ---------------------- |
| default | 带有 1px 边框          |
| primary | 基础,项目主色调,默认值 |
