Component({
  options: {
    multipleSlot: true,
    virtualHost: true,
  },
  properties: {
    style: {
      // 定义 style 属性可以拿到 style 属性上设置的值
      type: String,
    },
    type: {
      type: String,
      value: 'primary',
    },
    plain: {
      type: Boolean,
      value: false,
    },
    disabled: {
      type: Boolean,
      value: false,
    },
    openType: {
      type: String,
    },
    formType: {
      type: String,
    },
    size: {
      type: String,
      value: 'large',
    },
    square: {
      type: Boolean,
      value: false,
    },
    round: {
      type: Boolean,
      value: true,
    },
    block: {
      type: Boolean,
      value: false,
    },
    lang: {
      type: String,
      value: 'en',
    },
    sessionFrom: {
      type: String,
    },
    sendMessageTitle: {
      type: String,
    },
    sendMessagePath: {
      type: String,
    },
    sendMessageImg: {
      type: String,
    },
    showMessageCard: {
      type: String,
    },
    appParameter: {
      type: String,
    },
    loading: {
      type: Boolean,
      value: false,
    },
  },
  // 可以将 class 设为 externalClasses
  externalClasses: ['class', 'hover-class'],
  methods: {
    _onClick(event) {
      this.triggerEvent('point', event);
    },
    _bindGetUserInfo(event) {
      this.triggerEvent('getuserinfo', event.detail);
    },

    _bindContact(event) {
      this.triggerEvent('contact', event.detail);
    },

    _bindGetPhoneNumber(event) {
      this.triggerEvent('getphonenumber', event.detail);
    },

    _bindError(event) {
      this.triggerEvent('error', event.detail);
    },

    _bindLaunchApp(event) {
      this.triggerEvent('launchapp', event.detail);
    },

    _bindOpenSetting(event) {
      this.triggerEvent('opensetting', event.detail);
    },
  },
});
