Component({
  options: {
    addGlobalClass: true,
  },
  data: {
    list: [],
    pageNum: 1,
    totalPage: 1,
    scrollOffset: 0,
    hasRun: false,
  },
  properties: {
    reduceHeight: {
      type: String,
      value: null,
    },
    pageSize: {
      type: Number,
      value: 20,
    },
    isRefreshLoading: {
      type: Boolean,
      value: false,
    },
    color: {
      type: String,
      value: '#eef1f4',
    },
    params: {
      type: Object,
      value: null,
    },
    fetchFunction: {
      type: Object,
      value: () => {},
    },
  },

  pageLifetimes: {
    show() {
      this.fetchData(true);
    },
  },
  methods: {
    fetchData(isBack, type) {
      if (this.data.totalPage < this.data.pageNum && !isBack) {
        return;
      }
      if (isBack) {
        this.setData({ pageNum: 1 }, async () => {
          this.fetchRequest();
        });
      } else {
        this.fetchRequest(type);
      }
    },
    async fetchRequest(type) {
      const payload = Object.assign({}, this.properties.params, {
        pageNum: this.data.pageNum,
        pageSize: this.properties.pageSize,
      });
      const { data } = await this.properties.fetchFunction.fun(payload);
      if (data.list) {
        data.list = data.list.map((item) => {
          if (item.question && item.question.startsWith('{')) {
            item.question = JSON.parse(item.question);
          }
          return item;
        });
      }
      if (type === 'lower') {
        this.setData({ list: [...this.data.list, ...data.list], totalPage: data.totalPage }, () => {
          this.triggerEvent('getList', this.data.list);
        });
      } else {
        this.setData({ list: data.list, totalPage: data.totalPage }, () => {
          this.triggerEvent('getList', this.data.list);
        });
      }
    },
    bindrefresherrefresh() {
      this.setData({ pageNum: 1, totalPage: 1 }, async () => {
        await this.fetchData();
        this.setData({ isRefreshLoading: false });
      });
    },
    bindscrolltolower() {
      if (this.data.pageNum >= this.data.totalPage) {
        return;
      }
      //TODO 底部加载交互
      this.setData({ pageNum: this.data.pageNum + 1 }, () => {
        this.fetchData(false, 'lower');
      });
    },
  },
});
