Component({
  options: {
    addGlobalClass: true,
    multipleSlots: true,
  },
  properties: {
    tabList: {
      type: Array,
      value: [],
    },
    lineWidth: {
      type: Number,
      value: 40,
    },
    lineHeight: {
      type: Number,
      value: 3,
    },
    color: {
      type: String,
      value: '#eef1f4',
    },
    tabColor: {
      type: String,
      value: '#45A9ED',
    },
    heightStyle: {
      type: String,
      value: 'height:calc(100vh - 44px - 94rpx);',
    },
    params: {
      type: Object,
      value: null,
    },
    tabClass: {
      type: Object,
      value: null,
    },
    tabActiveClass: {
      type: Object,
      value: null,
    },
    hasInfo: {
      type: Boolean,
      value: false,
    },
    useParse: {
      type: Boolean,
      value: false,
    },
    fetchFunction: {
      type: Object,
      value: () => {},
    },
  },
  data: {
    list: [],
    value: 0,
    scrollTop: 0,
    pageNumList: [],
    refreshList: [],
    scrollList: [],
    totalPageList: [],
    index: 0,
  },
  pageLifetimes: {
    show() {
      const length = this.properties.tabList.length;
      for (let i = 0; i < length; i++) {
        this.data.pageNumList.push(1);
        this.data.refreshList.push(false);
        this.data.scrollList.push([]);
        this.data.totalPageList.push(0);
      }
      this.getBadge();
      this.initData();
    },
  },
  methods: {
    async initData() {
      for (let i = 0; i < this.properties.tabList.length; i++) {
        const myEventDetail = { isClick: false, index: i };
        this.triggerEvent('getIndex', myEventDetail);
        this.fetchData({ index: i });
      }
    },
    onSubTabsTap(e) {
      this.getBadge();
      const { index } = e.detail;
      const myEventDetail = { isClick: true, index: index };
      this.triggerEvent('getIndex', myEventDetail);
      this.setData({ value: index, index }, () => {
        this.fetchData({ index });
      });
    },
    async fetchData({ index, isLower, isRefresh }) {
      const { data } = await this.properties.fetchFunction.fun(
        Object.assign({}, this.properties.params, {
          pageNum: this.data.pageNumList[index],
          pageSize: 40,
        }),
      );
      let list = data.list || [];
      if (this.data.useParse) {
        list = list.map((item) => {
          if (item.question && item.question.startsWith('{')) {
            item.question = JSON.parse(item.question);
          }
          return item;
        });
      }
      const totalPage = data.totalPage;
      const scrollList = [...this.data.scrollList];
      scrollList[index] = isLower ? [...scrollList[index], ...list] : list;
      this.setData({ scrollList });
      const totalPageList = [...this.data.totalPageList];
      totalPageList[index] = totalPage;
      this.setData({ totalPageList });
      if (isRefresh) {
        const refreshList = [...this.data.refreshList];
        refreshList[index] = false;
        this.setData({ refreshList, scrollTop: 0 });
      }
      const myEventDetail = this.data.scrollList;
      this.triggerEvent('getList', myEventDetail);
    },
    bindrefresherrefresh() {
      this.getBadge();
      const pageNumList = [...this.data.pageNumList];
      const myEventDetail = { isClick: false, index: this.data.index };
      this.triggerEvent('getIndex', myEventDetail);
      pageNumList[this.data.index] = 1;
      this.setData({ pageNumList }, () => {
        this.fetchData({ index: this.data.index, isRefresh: true });
      });
    },
    bindscrolltolower() {
      const index = this.data.value;
      const pageNumList = [...this.data.pageNumList];
      const totalPageList = [...this.data.totalPageList];
      if (pageNumList[index] >= totalPageList[index]) {
        return;
      }
      pageNumList[index] = pageNumList[index] + 1;
      this.setData({ pageNumList }, () => {
        this.fetchData({ index: index, isLower: true });
      });
    },
    async getBadge() {
      if (this.data.hasInfo) {
        const { data } = await this.properties.fetchFunction.getTabBadge();
        this.setData({ dot: data });
      }
    },
  },
});
